<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">User List</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Task 45.40</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Hieu Nguyen</a>
        </div>
      </div>


      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="#" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>User List</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="#" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v2</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="#" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v3</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>User List</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">User List</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <!--table-->
<div class="container">
  <h2 style="text-align: center;">Danh sách người dùng</h2>
  <button id="btn-add-user" class="form-group btn btn-success"><i class="fa fa-plus"> </i> Thêm User</button>
  <table id="user-table" class="table table-bordered table-striped table-hover">
    <thead>
      <tr>
        <th>User Id</th>
        <th>Firstname</th>
        <th>Lastname</th>
        <th>Country</th>
        <th>Subject</th>
        <th>Customer Type</th>
        <th>Register Status</th>
        <th>Action</th>
      </tr>
    </thead>
    <tbody>
      
    </tbody>
  </table>
</div>
<!--Model add user-->
<div>
  <div id="modal-add-user" class="modal fade" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title">Thêm user</h5>
          <button class="close" data-dismiss="modal">&times;</button>
        </div>
        <div class="modal-body">
          <form>
            <div class="row form-group">
              <div class="col-sm-4">
                <label>First name</label>
              </div>
              <div class="col-sm-8">
                <input type="text" id="inp-add-user-firstname" class="form-control">
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label>Last name</label>
              </div>
              <div class="col-sm-8">
                <input type="text" id="inp-add-user-lastname" class="form-control">
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label>Subject</label>
              </div>
              <div class="col-sm-8">
                <input type="text" id="inp-add-user-subject" class="form-control">
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label>Country</label>
              </div>
              <div class="col-sm-8">
                <select id="select-add-user-country" class="form-control">
                  <option value="">Chọn Country</option>
                  <option value="VN">Việt Nam</option>
                  <option value="USA">USA</option>
                  <option value="AUS">Australia</option>
                  <option value="CAN">Canada</option>
                </select>
              </div>
            </div>
          </form>
        </div>
        <div class="modal-footer">
          <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
          <button class="btn btn-primary" id="btn-confirm-add-user">Thêm user</button>
        </div>
      </div>
    </div>
  </div>
</div>
<!--Model update user-->
<div>
  <div id="modal-update-user" class="modal fade" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title">Update user</h5>
          <button class="close" data-dismiss="modal">&times;</button>
        </div>
        <div class="modal-body">
          <form>
            <div class="row form-group">
              <div class="col-sm-4">
                <label>First name</label>
              </div>
              <div class="col-sm-8">
                <input type="text" id="inp-update-user-firstname" class="form-control">
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label>Last name</label>
              </div>
              <div class="col-sm-8">
                <input type="text" id="inp-update-user-lastname" class="form-control">
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label>Subject</label>
              </div>
              <div class="col-sm-8">
                <input type="text" id="inp-update-user-subject" class="form-control">
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label>Country</label>
              </div>
              <div class="col-sm-8">
                <select id="select-update-user-country" class="form-control">
                  <option value="">Chọn Country</option>
                  <option value="VN">Việt Nam</option>
                  <option value="USA">USA</option>
                  <option value="AUS">Australia</option>
                  <option value="CAN">Canada</option>
                </select>
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label>Customer Type</label>
              </div>
              <div class="col-sm-8">
                <select id="select-update-user-customer-type" class="form-control">
                  <option value="">Chọn Custome Type</option>
                  <option value="Standard">Standard</option>
                  <option value="Gold">Gold</option>
                  <option value="Premium">Premium</option>
                </select>
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label>Register Status</label>
              </div>
              <div class="col-sm-8">
                <select id="select-update-user-register-status" class="form-control">
                  <option value="">Chọn Register Status</option>
                  <option value="Accepted">Accepted</option>
                  <option value="Denied">Denied</option>
                  <option value="Standard">Standard</option>
                </select>
              </div>
            </div>
          </form>
        </div>
        <div class="modal-footer">
          <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
          <button class="btn btn-primary" id="btn-update-user">Update user</button>
        </div>
      </div>
    </div>
  </div>
</div>
<!-- Modal confirm delete   -->
<div>
  <div class="modal fade" tabindex="-1" id="modal-delete-user">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="h5-modal-title">Xác nhận xóa người dùng</h5>
          <button class="close" data-dismiss="modal">&times;</button>
        </div>
        <div class="modal-body">
          <label>Bạn có chắc chắn muốn xóa user này không?</label>
        </div>
        <div class="modal-footer">
          <button class="btn btn-danger" id="btn-confirm-delete-user">Xóa user</button>
          <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
        </div>
      </div>
    </div>
  </div>
</div>

    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> Task 45.40 29-06-2022.
  </footer>


</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<!-- AdminLTE for demo purposes -->
<script src="dist/js/demo.js"></script>
</body>
<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  var gUserList = []; //lưu danh sách user gọi từ server
    var gColNameList = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];
    const gCOL_ID = 0;
    const gCOL_FIRST_NAME = 1;
    const gCOL_LAST_NAME = 2;
    const gCOL_COUNTRY = 3;
    const gCOL_SUBJECT = 4;
    const gCOL_CUSTOMER_TYPE = 5;
    const gCOL_REGISTER_STATUS = 6;
    const gCOL_ACTION = 7;
    var gUserTable = $("#user-table").DataTable({
      columns: [
        {data: gColNameList[gCOL_ID]},
        {data: gColNameList[gCOL_FIRST_NAME]},
        {data: gColNameList[gCOL_LAST_NAME]},
        {data: gColNameList[gCOL_COUNTRY]},
        {data: gColNameList[gCOL_SUBJECT]},
        {data: gColNameList[gCOL_CUSTOMER_TYPE]},
        {data: gColNameList[gCOL_REGISTER_STATUS]},
        {data: gColNameList[gCOL_ACTION]},
      ],
      columnDefs: [
        {
          targets: gCOL_ACTION,
          className: "text-center",
          defaultContent: `
            <div class='btn-group'>
              <button class='btn btn-primary btn-edit'>Sửa</button>
              <button class='btn btn-danger btn-delete'>Xóa</button>
            </div>
          `
        }
      ]
    });
    const gBASE_URL = "http://42.115.221.44:8080/crud-api/users/";
    var gUserId = 0;

    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function() {
      callAjaxApiGetAllUsers();
      loadDataToTable(gUserList)
    })
    $("#user-table").on("click", ".btn-edit", function(){
      onBtnEditClick(this)
    });
    $("#user-table").on("click", ".btn-delete", function(){
      onBtnDeleteClick(this)
    });
    $("#btn-add-user").on("click", function(){
      $("#modal-add-user").modal("show");
    })
    $("#btn-confirm-add-user").on("click", onBtnConfirmAddUserClick)
    $("#btn-update-user").on("click", onBtnUpdateUserClick)
    $("#btn-confirm-delete-user").on("click", onBtnConfirmDeleteUserClick)
    
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onBtnEditClick(paramButtonElement) {
      "use strict";
      var vCurrentRow = $(paramButtonElement).closest("tr");
      var vRowData = gUserTable.row(vCurrentRow).data();
      gUserId = vRowData.id;
      console.log("Nút Sửa được ấn. Id là: " + gUserId);
      loadDataToModalUpdateUser(vRowData);
      $("#modal-update-user").modal("show");
    }
    function onBtnDeleteClick(paramButtonElement) {
      "use strict";
      var vCurrentRow = $(paramButtonElement).closest("tr");
      var vRowData = gUserTable.row(vCurrentRow).data();
      gUserId = vRowData.id;
      console.log("Nút Xóa được ấn. Id là: " + gUserId);
      $("#modal-delete-user").modal("show");
    }
    function onBtnConfirmAddUserClick() {
      var vUserObjToAdd = {
        firstname: "",
        lastname: "",
        country: "",
        subject: "",
      };
      //bước 1: lấy dữ liệu từ các input
      getDataFromModalAddUser(vUserObjToAdd);
      console.log("Ghi tạm đối tượng dữ liệu ra console");
      console.log(vUserObjToAdd);
      //bước 2: kiểm tra dữ liệu lấy từ các input
      var vCheckResult = validateUserDataToAdd(vUserObjToAdd);
      console.log("Kết quả kiểm tra dữ liệu là: " + vCheckResult);
      if (vCheckResult == true) {
        //bước 3: request tạo user mới
        callAjaxApiAddUser(vUserObjToAdd);
        //B4: xử lý hiển thị
        callAjaxApiGetAllUsers();
        loadDataToTable(gUserList);
        resetModalAddUser();
        $("#modal-add-user").modal("hide")
      }
    }
    function onBtnUpdateUserClick() {
      var vUserObjToUpdate = {
        firstname: "",
        lastname: "",
        country: "",
        subject: "",
        customerType: "",
        registerStatus: "",
      };
      //bước 1: lấy dữ liệu từ các input
      getDataFromModalUpdateUser(vUserObjToUpdate);
      console.log("Ghi tạm đối tượng dữ liệu ra console");
      console.log(vUserObjToUpdate);
      //bước 2: kiểm tra dữ liệu lấy từ các input
      var vCheckResult = validateUserDataToUpdate(vUserObjToUpdate);
      console.log("Kết quả kiểm tra dữ liệu là: " + vCheckResult);
      if (vCheckResult == true) {
        //bước 3: tạo request update user data
        callAjaxApiUpdateUserData(vUserObjToUpdate);
        //B4: xử lý hiển thị
        callAjaxApiGetAllUsers();
        loadDataToTable(gUserList);
        resetModalUpdateUser();
        $("#modal-update-user").modal("hide")
      }
    }
    function onBtnConfirmDeleteUserClick() {
      //bước 3: tạo request update user data
      callAjaxApiDeleteUserData(gUserId);
      //B4: xử lý hiển thị
      callAjaxApiGetAllUsers();
      loadDataToTable(gUserList);
      $("#modal-delete-user").modal("hide")
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function callAjaxApiGetAllUsers() {
      $.ajax({
        async: false,
        url: gBASE_URL,
        type: "GET",
        dataType: "json",
        success: function(paramResponseObj) {
          console.log(paramResponseObj);
          gUserList = paramResponseObj
        },
        error: function (ajaxContext) {
          console.log(ajaxContext)
        }
      })
    }
    function loadDataToTable(paramUserList) {
      gUserTable.clear()
        .rows.add(paramUserList)
        .draw()
    }
    function getDataFromModalAddUser(paramUserObject) { //hàm đọc dữ liệu từ các input
      paramUserObject.firstname = $.trim($("#inp-add-user-firstname").val());
      paramUserObject.lastname = $.trim($("#inp-add-user-lastname").val());
      paramUserObject.subject = $.trim($("#inp-add-user-subject").val());
      paramUserObject.country = $("#select-add-user-country").val();
    }
    function validateUserDataToAdd(paramUserObject) { //hàm kiểm tra dữ liệu lấy từ các input
      var vCheckResult = false;
      if (paramUserObject.firstname == "") {
        console.log("Chưa nhập First name");
        alert("Chưa nhập First name")
      }
      else if (paramUserObject.lastname == "") {
        console.log("Chưa nhập Last name");
        alert("Chưa nhập Last name")
      }
      else if (paramUserObject.subject == "") {
        console.log("Chưa nhập Subject");
        alert("Chưa nhập Subject")
      } 
      else if (paramUserObject.country == "") {
        console.log("Chưa chọn Country");
        alert("Chưa chọn Country")
      }
      else {
        vCheckResult = true
      }
      return vCheckResult
    }
    function callAjaxApiAddUser(paramUserObject) { //tạo và gửi request add new user 
      $.ajax({
        async: false,
        url: gBASE_URL,
        type: "POST",
        contentType: "application/json; charset=utf-8",
        data: JSON.stringify(paramUserObject),
        success: function (paramResponse) {
          console.log(JSON.stringify(paramResponse, null, 2));
          alert("Thêm user thành công! Id user mới là: " + paramResponse.id);
        },
        error: function (err) {
          console.log(err)
          alert("Thêm user không thành công!\n\nLỗi là: " + err.responseText);
        }
      })
    }
    function resetModalAddUser() {
      $("#inp-add-user-firstname").val("");
      $("#inp-add-user-lastname").val("");
      $("#inp-add-user-subject").val("");
      $("#select-add-user-country").val("");
    }
    function resetModalUpdateUser() {
      $("#inp-update-user-firstname").val("");
      $("#inp-update-user-lastname").val("");
      $("#inp-update-user-subject").val("");
      $("#select-update-user-country").val("");
      $("#select-update-user-customer-type").val("");
      $("#select-update-user-register-status").val("");
    }
    function loadDataToModalUpdateUser(paramRowData) {
      $("#inp-update-user-firstname").val(paramRowData.firstname);
      $("#inp-update-user-lastname").val(paramRowData.lastname);
      $("#inp-update-user-subject").val(paramRowData.subject);
      $("#select-update-user-country").val(paramRowData.country);
      $("#select-update-user-customer-type").val(paramRowData.customerType);
      $("#select-update-user-register-status").val(paramRowData.registerStatus);
    }
    function getDataFromModalUpdateUser(paramUserObject) { //hàm đọc dữ liệu từ các input
      paramUserObject.firstname = $.trim($("#inp-update-user-firstname").val());
      paramUserObject.lastname = $.trim($("#inp-update-user-lastname").val());
      paramUserObject.subject = $.trim($("#inp-update-user-subject").val());
      paramUserObject.country = $("#select-update-user-country").val();
      paramUserObject.customerType = $("#select-update-user-customer-type").val();
      paramUserObject.registerStatus = $("#select-update-user-register-status").val();
    }
    function validateUserDataToUpdate(paramUserObject) { //hàm kiểm tra dữ liệu lấy từ các input
      var vCheckResult = false;
      if (paramUserObject.firstname == "") {
        console.log("Chưa nhập First name");
        alert("Chưa nhập First name")
      }
      else if (paramUserObject.lastname == "") {
        console.log("Chưa nhập Last name");
        alert("Chưa nhập Last name")
      }
      else if (paramUserObject.subject == "") {
        console.log("Chưa nhập Subject");
        alert("Chưa nhập Subject")
      } 
      else if (paramUserObject.country == "") {
        console.log("Chưa chọn Country");
        alert("Chưa chọn Country")
      }
      else if (paramUserObject.customerType == "") {
        console.log("Chưa chọn Customer Type");
        alert("Chưa chọn Customer Type")
      }
      else if (paramUserObject.registerStatus == "") {
        console.log("Chưa chọn RegisterStatus");
        alert("Chưa chọn Register Status")
      }
      else {
        vCheckResult = true
      }
      return vCheckResult
    }
    function callAjaxApiUpdateUserData(paramUserObject) { //tạo và gửi request update user data
      $.ajax({
        async: false,
        url: gBASE_URL + gUserId,
        type: "PUT",
        contentType: "application/json; charset=utf-8",
        data: JSON.stringify(paramUserObject),
        success: function (paramResponse) {
          console.log(JSON.stringify(paramResponse, null, 2));
          alert("Cập nhật thông tin thành công cho User Id: " + paramResponse.id);
        },
        error: function (err) {
          console.log(err)
          alert("Có lỗi! Lỗi là:\n\n" + err.responseText)
        }
      })
    }
    function callAjaxApiDeleteUserData(paramId) {
      "use strict";
      $.ajax({
        async: false,
        url: gBASE_URL + paramId,
        type: "DELETE",
        dataType: "json",
        success: function (paramResponse) {
          console.log("Xóa người dùng thành công, response là:");
          console.log(paramResponse);
          alert("Xóa người dùng thành công!")
        },
        error: function (paramError) {
          console.log("Có lỗi, lỗi là:");
          console.log(JSON.stringify(paramError, null, 2));
          alert("Có lỗi, lỗi là:\n\n" + paramError.responseText)
        }
      })
    }

</script>
</html>
